/*
 * Craftyslide
 * Created by: Abid Din - http://craftedpixelz.co.uk
 * Version: 1.0
 * Copyright: Crafted Pixelz
 * License: MIT license
 * Updated: 7th June 2011
 */

(function( $ )
{
    $.fn.craftyslide = function( zoptions )
    {
        var defaults = {"width":600,"height":300,"pagination":true,"fadetime":350,"delay":500};
        var options = $.extend( defaults, zoptions );
        return this.each( function()
        {
            var $this = $( this );
            var $slides = $this.find( "ul li" );
            $slides.not( ':first' ).hide();
            function paginate()
            {
                $this.append( "<ol id='pagination' />" );
                var i = 1;
                $slides.each( function()
                {
                    $( this ).attr( "id", "slide" + i );
                    $( "#pagination" ).append( "<li><a href='#slide" + i + "'>" + i + "</a></li>" );
                    i++;
                } );
                $( "#pagination li a:first" ).addClass( "active" );
            }

            function captions()
            {
                $slides.each( function()
                {
                    $caption = $( this ).find( "img" ).attr( "title" );
                    if( $caption !== undefined )
                    {
                        $( this ).prepend( "<p class='caption'>" + $caption + "</p>" );
                    }
                    $slides.filter( ":first" ).find( ".caption" ).css( "bottom", 0 );
                } );
            }

            function manual()
            {
                var $pagination = $( "#pagination li a" );
                $pagination.click( function( e )
                {
                    e.preventDefault();
                    var $current = $( this.hash );
                    if( $current.is( ":hidden" ) )
                    {
                        $slides.fadeOut( options.fadetime );
                        $current.fadeIn( options.fadetime );
                        $pagination.removeClass( "active" );
                        $( this ).addClass( "active" );
                        $( ".caption" ).css( "bottom", "-37px" );
                        $current.find( ".caption" ).delay( 300 ).animate( {bottom:0}, 300 );
                    }
                } );
            }

            function auto()
            {
                setInterval( function()
                {
                    $slides.filter( ":first-child" ).fadeOut( options.fadetime ).next( "li" ).fadeIn( options.fadetime ).end().appendTo( "#slideshow ul" );
                    $slides.each( function()
                    {
                        if( $slides.is( ":visible" ) )
                        {
                            $( ".caption" ).css( "bottom", "-37px" );
                            $( this ).find( ".caption" ).delay( 300 ).animate( {bottom:0}, 300 );
                        }
                    } );
                }, options.delay );
            }

            $this.width( options.width );
            $this.find( "ul, li" ).width( options.width );
            $this.height( options.height );
            $this.find( "ul, li" ).height( options.height );
            if( options.pagination === true )
            {
                paginate();
            }
            else
            {
                auto();
            }
            captions();
            manual();
        } );
    };
})( jQuery );